package 
{
	import flash.display.BitmapData;
	import flash.display.*;
	import flash.geom.Point;
	import flash.geom.Rectangle;

	public class AnimImage
	{
		protected var bitmap:Array = null;
		protected var nFrames:int
		protected var width:int, height:int;
		protected var handle:Point;
		protected var rect:Rectangle;
		public function AnimImage(image:DisplayObject, width:int, height:int, nFrames:int, hx:int=0, hy:int=0)
		{
			bitmap = new Array(nFrames);
			this.nFrames = nFrames;
			this.width = width;
			this.height = height;
			splitImage(image);
			handle = new Point(hx, hy);
			rect = new Rectangle(0, 0, width, height);
		}
		protected function createBitmapData(image:DisplayObject):BitmapData
		{
			var bm:BitmapData = new BitmapData(image.width, image.height, true, 0x00FFFFFF);
			bm.draw(image);
			return bm;
		}
		protected function splitImage(image:DisplayObject):void
		{
			if (image)
			{
				var tmpBitmap:BitmapData = new BitmapData(image.width, image.height, true, 0x00000000);
				tmpBitmap.draw(image);
			}
			for (var i:int = 0; i < nFrames; ++i )
			{
				bitmap[i] = new BitmapData(width, height, true, 0x00000000);
				if(image)
					bitmap[i].copyPixels(tmpBitmap, new Rectangle(getFramePosX(i, image.width), getFramePosY(i, image.width), width, height), new Point(0, 0));
			}
		}
		protected function getFramePosX(fr:uint, imgWidth:int):uint
		{
			return (fr*width)%imgWidth;
		}
		protected function getFramePosY(fr:uint, imgWidth:int):uint
		{
			return Math.floor((fr * width)/imgWidth)*height;
		}
		public function draw(backbuffer:BitmapData, x:int, y:int, frame:int=0, alphaBitmap:BitmapData=null):void
		{
			backbuffer.copyPixels(bitmap[frame] as BitmapData, rect, new Point(x, y).subtract(handle), alphaBitmap, new Point(0, 0), true);
		}
		public function getFrame(fr:int=0):BitmapData
		{
			return bitmap[fr] as BitmapData;
		}
		/*public function setFrame(fr:int, bitmap:BitmapData):void
		{
			this.bitmap[fr].copyPixels(bitmap, rect, new Point());
		}*/
		public function get Width():int
		{
			return width;
		}
		public function get Height():int
		{
			return height;
		}
		public function get Handle():Point
		{
			return handle;
		}
	}
}