package
{
	import flash.geom.Point;
	import utility.CUtility;
	public class CAttack_Circle extends CAttack_Projectile
	{
		protected var N:int;
		public function CAttack_Circle(height:int, N:int)
		{
			this.targetHeight = height;
			this.N = N;
		}
		public function init_player(target:Point):void
		{
			this.target = target.clone();
			faction = 0;
		}
		public function init_enemy(dragon:CDragon):void
		{
			if(dragon)
				this.target = dragon.pos.clone();
			else
				this.target = null;
			faction = 1;
		}
		override public function execute(caster:CCreature, gm:CGameManager):void
		{
			super.execute(caster, gm);
			var angle:Number;
			if (target)
				angle = Math.atan2(target.y - caster.pos.y, target.x - caster.pos.x);
			else
				angle = CUtility.rnd(0, 2 * Math.PI);
				
			var dx:Number;
			if (caster.movement.look_direction == 0)
				dx = caster.shot_offset.x;
			else
				dx = -caster.shot_offset.x;
				
			for (var i:int = 0; i < N; ++i )
			{
				var targetPos:Point = new Point(dx+caster.pos.x+10*Math.cos(angle + i * 2 * Math.PI / N), caster.pos.y+10*Math.sin(angle + i * 2 * Math.PI / N));
				var proj:CProjectile = new CProjectile();
				proj.init_gameObject(caster.pos, ResManager.IMG_PROJECTILES, frame, 4);
				proj.init_projectile(caster, 120, faction, targetHeight, targetPos, targetHeight, new CAttackRef(this, new CStats().init_stats_copy(caster.stats), caster));
				var explo:CAnimation = new CAnimation();
				explo.init_gameObject(null, ResManager.IMG_EXPLOSIONS, 0);
				explo.init_anim(4, 0.2, 1);
				proj.explosion = explo;
				gm.Game.newObjectList.addItem(proj);
			}
		}
	}
}