package
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	public class CButton
	{
		protected var gfx:BitmapData;
		protected var mOver:Boolean = false;
		protected var pressed:Boolean = false;
		protected var mouseover_gfx:BitmapData;
		protected var mousedown_gfx:BitmapData;
		protected var rect:Rectangle;
		public var pos:Point;
		public function CButton(pos:Point, gfx:BitmapData)
		{
			this.pos = pos;
			this.gfx = gfx;
			var colorTrafo:ColorTransform;
			rect = new Rectangle(0, 0, gfx.width, gfx.height);
			mouseover_gfx = new BitmapData(gfx.width, gfx.height, true, 0x00000000);
			mouseover_gfx.copyPixels(gfx, rect, new Point(0, 0), null, null, true);
			colorTrafo = new ColorTransform(0.75, 0.75, 0.75);
			mouseover_gfx.colorTransform(rect, colorTrafo);
			mousedown_gfx = new BitmapData(gfx.width, gfx.height, true, 0x00000000);
			mousedown_gfx.copyPixels(gfx, rect, new Point(0, 0), null, null, true);
			colorTrafo = new ColorTransform(0.5, 0.5, 0.5);
			mousedown_gfx.colorTransform(rect, colorTrafo);
		}
		public function hit(mx:int, my:int, mDown:Boolean, mUp:Boolean):Boolean
		{
			if (mouseover(mx, my))
			{
				mOver = true;
				if(mDown)
					pressed = true;
			}
			else
				mOver = false;
			if (mUp)
			{
				if (mOver && pressed)
				{
					pressed = false;
					return true;
				}
				else
					pressed = false;
			}	
			return false;
		}
		public function mouseover(mx:int, my:int):Boolean
		{
			if (pos.x < mx && mx < pos.x + gfx.width && pos.y < my && my < pos.y + gfx.height)
			{
				return true;
			}
			return false;
		}
		public function draw(backbuffer:BitmapData):void
		{
			if (mOver && !pressed)
				backbuffer.copyPixels(mouseover_gfx, rect, pos, null, null, true);
			else if(pressed)
				backbuffer.copyPixels(mousedown_gfx, rect, pos, null, null, true);
			else
				backbuffer.copyPixels(gfx, rect, pos, null, null, true);
		}
	}
}