package
{
	import flash.display.BitmapData;
	import flash.geom.Point;
	import org.flashdevelop.utils.FlashConnect;
	public class CDragon extends CCreature
	{
		protected var scroll:Point;
		protected var move:Boolean = false;
		protected var target_timer:Number, target_frame:int = 0, target_tmp:Point, target_times:int;
		public var level:int, maxLevel:int = 5;
		public var coloredImg:Array;
		public var color:CColor = new CColor(0, 0, 0);
		protected var gfx_offsets:Array = new Array(new Point(), new Point(), new Point(), new Point(), new Point(5, 0), new Point(5, 0));
		protected var shot_offsets:Array = new Array(new Point(1, 8), new Point(10, 5), new Point(12, 13), new Point(13, 18), new Point(14, 20), new Point(14, 20));
		protected var level_heights:Array = new Array(12, 14, 20, 25, 30, 30);
		protected var stats_per_level:CStats = new CStats();
		public function CDragon(scroll:Point)
		{
			this.scroll = scroll;
		}
		public function placeDragon(level:int, map:CTileMap, x:int, y:int):void
		{
			if (map.onMapInt(x, y))
			{
				this.level = level;
				pos = new Point(x * map.tilesize + map.tilesize / 2, y * map.tilesize + map.tilesize / 2);
				sortField = pos.y;
				coloredImg = new Array(2);
				setColorGraphics(this.level, new CColor());
				stats_per_level.init_stats(50, 50, 15, 10, 10, 10, 2);
				//stats.init_stats(500, 500, 80, 50, 40, 50);
			}
		}
		public function setColorGraphics(level:int, newColor:CColor):void
		{
			var resultColor:CColor=new CColor((color.red+newColor.red)/2, (color.green+newColor.green)/2, (color.blue+newColor.blue)/2)
			var img:AnimImage = ResManager.img[ResManager.IMG_DRAGONS];
			if (coloredImg[0] is ColorImage)
				coloredImg[0].remove();
			if (coloredImg[1] is ColorImage)
				coloredImg[1].remove();
			coloredImg[0] = new ColorImage(img, level*2, resultColor);
			coloredImg[1] = new ColorImage(img, level * 2 + 1, resultColor);
			color = resultColor;
			shot_offset = shot_offsets[level];
			gfx_offset = gfx_offsets[level];
			size = level_heights[level];
			frame = 2 * level;
		}
		override public function update(gm:CGameManager, dt:Number):void
		{
			super.update(gm, dt);
			target_timer -= dt;
			scroll.x = pos.x - gm.screenDim.x/2;
			scroll.y = pos.y - gm.screenDim.y/2;
			var mousePosOnMap:Point = scroll.add(gm.mousePos.clone());
			if (gm.mouseDown)
			{
				move = true
				target_timer = 0.2;
				target_tmp = mousePosOnMap.clone();
				target_times = 4;
			}
			if (gm.mouseUp)
				move = false;
			if (move)
			{
				movement.target = mousePosOnMap.clone();
			}
			attack(gm, dt, gm.key1_down, 0);
			attack(gm, dt, gm.key2_down, 1);
			attack(gm, dt, gm.key3_down, 2);
			attack(gm, dt, gm.key4_down, 3);
			passage(gm);
			collision(gm, dt);
			evolve(gm);
		}
		protected function attack(gm:CGameManager, dt:Number, keyDown:Boolean, id:int):void
		{
			if (id<0||id>=attacks.length || !attacks[id]) return;
			attacks[id].update(gm, dt);
			if (keyDown && attacks[id].ready())
			{
				attacks[id].init_player(scroll.add(gm.mousePos.clone()));
				attacks[id].execute(this, gm);
			}
		}
		override public function draw(backbuffer:BitmapData, scroll:Point, gm:CGameManager):void
		{
			if (movement.look_direction == 0)
			{
				coloredImg[0].draw(backbuffer, gm.screenDim.x / 2 - gfx_offset.x, gm.screenDim.y / 2 + gfx_offset.y);
				ResManager.img[ResManager.IMG_DRAGON_BORDERS].draw(backbuffer, gm.screenDim.x / 2-gfx_offset.x, gm.screenDim.y / 2 + gfx_offset.y, frame);
				//(ResManager.img[imgId] as AnimImage).draw(backbuffer, gm.screenDim.x / 2 - gfx_offset.x, gm.screenDim.y / 2 + gfx_offset.y, frame);
			}
			else
			{
				coloredImg[1].draw(backbuffer, gm.screenDim.x / 2 + gfx_offset.x, gm.screenDim.y / 2 + gfx_offset.y);
				(ResManager.img[ResManager.IMG_DRAGON_BORDERS] as AnimImage).draw(backbuffer, gm.screenDim.x / 2+gfx_offset.x, gm.screenDim.y / 2 + gfx_offset.y, frame + movement.look_direction);
				//(ResManager.img[imgId] as AnimImage).draw(backbuffer, gm.screenDim.x / 2 + gfx_offset.x, gm.screenDim.y / 2 + gfx_offset.y, frame + movement.look_direction);
			}
			drawHpBar(backbuffer, scroll, 1);
		}
		public function drawTarget(backbuffer:BitmapData, gm:CGameManager):void
		{
			if (target_times <= 0) return;
			if (target_timer <= 0)
			{
				target_timer = 0.2;
				target_frame = 1 - target_frame;
				--target_times;
			}
			ResManager.img[ResManager.IMG_TARGET].draw(backbuffer, target_tmp.x-scroll.x, target_tmp.y-scroll.y, target_frame);
		}
		public function evolve(gm:CGameManager):void
		{
			if (level < maxLevel && !gm.Game.world.currentMap.finished)
			{
				if (gm.Game.world.currentMap.allEnemiesDead())
				{
					++level;
					stats.add(1, stats_per_level);
	//				frame += 2;
					gm.Game.world.currentMap.finished = true;
					gm.Game.subState = CGameState_Ingame.STATE_CHOOSECOLOR;
					stats.hp += Math.max(0, (stats.maxHp - stats.hp) / 2);
					attacks[0].N += 2;
					attacks[0].cooldown -= 0.1;
					movement.speed += 2;
				}
			}
			else if (level >= maxLevel)
			{
				if (gm.Game.world.currentMap.allEnemiesDead())
					gm.Game.world.currentMap.finished = true;
			}
		}
	}
}