package
{
	import flash.geom.Point;
	import mx.collections.ArrayCollection;
	import flash.display.BitmapData;
	import mx.core.FlexGlobals;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	public class CGameManager
	{
		public var backbuffer:BitmapData;
		public var screenDim:Point;
		public var mousePos:Point;
		public var mouseDown:Boolean, mouseUp:Boolean, mouseClick:Boolean;
		public var key1_down:Boolean, key2_down:Boolean, key3_down:Boolean, key4_down:Boolean;
		
		protected var lastFrameTime:Date;
		protected var states:ArrayCollection;
		protected var lastState:CGameState, currentState:CGameState;
		
		public var channel:SoundChannel;
		public var stf:SoundTransform = new SoundTransform(0.2); 
		public function CGameManager(defaultStateId:int = 0)
		{
			screenDim = new Point(FlexGlobals.topLevelApplication.width, FlexGlobals.topLevelApplication.height);
			backbuffer = new BitmapData(screenDim.x, screenDim.y, false);
			lastState = null;
			currentState = null;
			states = new ArrayCollection();
			initStates(defaultStateId);
			lastFrameTime = new Date();
			mousePos = new Point();
		}
		public function get State():int
		{
			return currentState.stateId;
		}
		
		public function update():void
		{
			var currentFrameTime:Date = new Date();
			var dt:Number = Math.min((currentFrameTime.getTime() - lastFrameTime.getTime()) / 1000, 0.034);
			lastFrameTime = currentFrameTime;
			//FlashConnect.trace("fps = "+1.0/dt);
			currentState.update(dt);
			currentState.draw(backbuffer);
			mouseClick = mouseDown = mouseUp = false;
		}
		public function changeState(nextState:int):void
		{
			lastState = currentState;
			if(currentState)
				currentState.leave();
			currentState = states.getItemAt(nextState) as CGameState;
			if(currentState)
				currentState.enter();
			else
				throw new Error("currentState==null");
		}
		protected function initStates(startingState:int = 0):void
		{
			states.addItem(new CGameState_Ingame(this));
			states.addItem(new CGameState_MainMenu(this));
			changeState(startingState);
		}
		public function setMousePos(x:int, y:int):void
		{
			mousePos.x = x;
			mousePos.y = y;
		}
		public function get Game():CGameState_Ingame
		{
			return states[GameStates.INGAME];
		}
	}
}