package 
{
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.display.*;
	import utility.CUtility;
	import org.flashdevelop.utils.FlashConnect;
	public class CGameObject
	{
		public var pos:Point;
		public var imgId:int, frame:int;
		public var collisionRadius:int;
		public var active:Boolean = true;
		public var sortField:Number;
		public function CGameObject()
		{
		}
		public function init_gameObject(pos:Point, imgId:int=0, fr:int=0, coll_rad:int=-1, active:Boolean=true):void
		{
			this.imgId = imgId;
			frame = fr;
			if(pos)
				this.pos = pos.clone();
			else
				this.pos = new Point();
			sortField = this.pos.y;
			collisionRadius = coll_rad;
			this.active = active;
		}
		public function draw(backbuffer:BitmapData, scroll:Point, gm:CGameManager):void
		{
			ResManager.img[imgId].draw(backbuffer, pos.x-scroll.x, pos.y-scroll.y, frame);
		}
		public function update(gameManager:CGameManager, dt:Number):void{}
		public function remove():void
		{
			pos = null;
		}
		public function outsideScreen(gameManager:CGameManager, offset:int=0):Boolean
		{
			if (pos.x < -offset || pos.x > gameManager.screenDim.x+offset || pos.y < -offset || pos.y > gameManager.screenDim.y+offset)
				return true;
			return false;
		}
		public function collidesWith(other:CGameObject):Boolean
		{
			if (CUtility.inRange(pos, other.pos, collisionRadius+other.collisionRadius))
			{
				return true;
			}
			return false;
		}
	}
}