package
{
	import flash.display.BitmapData
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import mx.collections.ArrayCollection;
	import org.flashdevelop.utils.FlashConnect;
	import mx.collections.SortField;
	import mx.collections.Sort;
	import flash.filters.DropShadowFilter;
	public final class CGameState_Ingame extends CGameState
	{
		public static const STATE_INGAME:int = 0, STATE_CHOOSECOLOR:int = 1, STATE_GAMEOVER:int = 2, STATE_VICTORY:int = 3;
		private var scroll:Point;
		public var subState:int = STATE_INGAME;
		public var world:CWorld;
		public var dragon:CDragon;
		public var objectList:ArrayCollection, newObjectList:ArrayCollection, removedGameObjects:ArrayCollection;
		protected var b_red:CButton = new CButton(new Point(160, 144+32), ResManager.img[ResManager.IMG_COLORBUTTONS].getFrame(0));
		protected var b_green:CButton = new CButton(new Point(160+64, 144+32), ResManager.img[ResManager.IMG_COLORBUTTONS].getFrame(1));
		protected var b_blue:CButton = new CButton(new Point(160 + 128, 144 + 32), ResManager.img[ResManager.IMG_COLORBUTTONS].getFrame(2));
		protected var big_text_black_format:TextFormat = new TextFormat("papyrus", 24, 0);
		protected var intro_text_white_format:TextFormat = new TextFormat("papyrus", 14, 0);
		public var win_text:CText;
		public var gameover_text:CText;
		public var intro_text:CText;
		public function CGameState_Ingame(gm:CGameManager, stateId:int=1)
		{
			this.stateId = stateId;
			gameManager = gm;
			scroll = new Point();
			objectList = new ArrayCollection();
			newObjectList = new ArrayCollection();
			removedGameObjects = new ArrayCollection();
			initSort();
			gameover_text = new CText();
			var gameover_textfield:TextField = new TextField();
			gameover_textfield.defaultTextFormat = big_text_black_format;
			gameover_textfield.width = 200;
			gameover_textfield.height = 30;
			gameover_textfield.filters = [new DropShadowFilter()];
			gameover_text.init("Game Over!", gameover_textfield, big_text_black_format, true);
			
			var win_textfield:TextField = new TextField();
			win_textfield.defaultTextFormat = big_text_black_format;
			win_textfield.width = 200;
			win_textfield.height = 30;
			win_textfield.filters = [new DropShadowFilter()];
			win_text = new CText();
			win_text.init("Victory!", win_textfield, big_text_black_format, true);
			
			var intro_textfield:TextField = new TextField();
			intro_textfield.defaultTextFormat = intro_text_white_format;
			intro_textfield.width = 200;
			intro_textfield.height = 200;
			//intro_textfield.filters = [new DropShadowFilter()];
			intro_textfield.wordWrap = true;
			intro_text = new CText();
			intro_text.init("Click with your mouse to walk and aim.\n\nPress SPACE to spit fire.", intro_textfield, intro_text_white_format, true);
			/*
			format.font = font;
			format.size = size;
			format.color = color;
			this.text.wordWrap = wordWrap;
			this.text.defaultTextFormat = format;
			this.text.width = dx;
			this.text.height = dy;
			if(shadow)
				this.text.filters = [new DropShadowFilter()];
			this.midhandle = midhandle;
			if (imgBuffer)
				imgBuffer.dispose();
			imgBuffer = new BitmapData(this.text.width, this.text.height, true, 0);
			setText(text);*/
		}
		override public function enter():void
		{
			subState = STATE_INGAME;
			world = new CWorld();
			world.loadWorld(gameManager);
			dragon = new CDragon(scroll);
			dragon.init_gameObject(null, ResManager.IMG_DRAGONS, 0, 10);
			var stats:CStats = new CStats();
			stats.init_stats(500, 500, 80, 50, 40, 50);
			dragon.init_creature(50, 12, stats, 0, new Point(5, 0), new Point(14, 20));
			dragon.placeDragon(0, world.currentMap, 2, 5);
			dragon.attacks[0] = new CAttack_FireBurst(1);
			(dragon.attacks[0] as CAttack_FireBurst).init_attack(50, 1, 0, CAttack.MAGIC, 1000, 1);
			objectList.addItem(dragon);
		}
		override public function leave():void
		{
			objectList.removeAll();
			newObjectList.removeAll();
			removedGameObjects.removeAll();
		}
		override public function update(dt:Number):void
		{
			switch(subState)
			{
				case STATE_INGAME:
					addNewObjects();
					for each(var obj:CGameObject in objectList)
					{
						if(obj.active)
							obj.update(gameManager, dt);
					}
					removeObjects();
					if (dragon.stats.dead())
					{
						subState = STATE_GAMEOVER;
					}
					if (world.won())
						subState = STATE_VICTORY;
					break;
				case STATE_CHOOSECOLOR:
					if (b_red.hit(gameManager.mousePos.x, gameManager.mousePos.y, gameManager.mouseDown, gameManager.mouseUp))
					{
						dragon.setColorGraphics(dragon.level, new CColor(128, 0, 0));
						subState = STATE_INGAME;
					}
					if (b_green.hit(gameManager.mousePos.x, gameManager.mousePos.y, gameManager.mouseDown, gameManager.mouseUp))
					{
						dragon.setColorGraphics(dragon.level, new CColor(0, 128, 0));
						subState = STATE_INGAME;
					}
					if (b_blue.hit(gameManager.mousePos.x, gameManager.mousePos.y, gameManager.mouseDown, gameManager.mouseUp))
					{
						dragon.setColorGraphics(dragon.level, new CColor(0, 0, 128));
						subState = STATE_INGAME;
					}
					break;
				case STATE_GAMEOVER:
				case STATE_VICTORY:
					if (gameManager.mouseClick)
						gameManager.changeState(GameStates.MAINMENU);
					break;
			}
		}
		override public function draw(backbuffer:BitmapData):void
		{
			sortList();
			backbuffer.fillRect(new Rectangle(0, 0, gameManager.screenDim.x, gameManager.screenDim.y), 0xFF250025);
			world.currentMap.draw(backbuffer, scroll);
			if (world.currentMap == world.introMap)
				intro_text.draw(backbuffer, new Point(150 - Math.floor(scroll.x), 100 - Math.floor(scroll.y)));
			dragon.drawTarget(backbuffer, gameManager);
			for each(var obj:CGameObject in objectList)
			{
				if(obj.active)
					obj.draw(backbuffer, scroll, gameManager);
			}
			
			if (subState == STATE_CHOOSECOLOR)
			{
				b_red.draw(backbuffer);
				b_green.draw(backbuffer);
				b_blue.draw(backbuffer);
			}
			else if (subState == STATE_GAMEOVER)
			{
				gameover_text.draw(backbuffer, new Point(gameManager.screenDim.x / 2, gameManager.screenDim.y / 2-32));
			}
			else if (subState == STATE_VICTORY)
			{
				win_text.draw(backbuffer, new Point(gameManager.screenDim.x / 2, gameManager.screenDim.y / 2 - 32));
			}
			
		}
		protected function sortList():void
		{
			objectList.refresh();	
		}
		protected function initSort():void
		{
			var collectionSortfield:SortField = new SortField();
			collectionSortfield.name = "sortField";
			collectionSortfield.numeric = true;
			var collectionSort:Sort = new Sort();
			collectionSort.fields = [collectionSortfield];
			objectList.sort = collectionSort;
		}
		protected function addNewObjects():void
		{
			objectList.addAll(newObjectList);
			newObjectList.removeAll();
		}
		protected function removeObjects():void
		{
			for each(var del:CGameObject in removedGameObjects)
			{
				for (var i:uint = 0; i < objectList.length; ++i)
				{
					if (objectList.getItemAt(i) == del)
					{
						objectList.removeItemAt(i);
						break;
					}
				}
			}
			removedGameObjects.removeAll();
		}
		
	}
}