package
{
	import flash.geom.Point;
	import utility.CUtility;
	import org.flashdevelop.utils.FlashConnect;
	public class CMovement
	{
		public var look_direction:int;
		public var speed:Number;
		protected var direction:Point=new Point();
		public var anim_timer:Number;
		public var target:Point = null;
		public var evade_direction:Point = null;
		public function CMovement(spd:Number)
		{
			speed = spd;
		}
		public function update(map:CTileMap, obj:CGameObject, dt:Number):void
		{
			if (target && !evade_direction)
			{
				Direction = target.subtract(obj.pos);
				moveForward(map, obj, dt);
				look_direction = CUtility.sgn(direction.x);
				if (look_direction >= 0)
					look_direction = 0;
				else
					look_direction = 1;
			}
			else
			{
				if (target && evade_direction)
				{
					Direction = evade_direction.clone();
					moveForward(map, obj, dt);
				}
			}
		}
		protected function moveForward(map:CTileMap, obj:CGameObject, dt:Number):void
		{
				if (!CUtility.inRange(target, obj.pos, speed * dt * 1.1))
				{
					if (!map.collision(obj.pos.x + dt * speed * direction.x, obj.pos.y + dt * speed * direction.y))
					{
						obj.pos.x += dt * speed * direction.x;
						obj.pos.y += dt * speed * direction.y;
					}
					else
					{
						if (!map.collision(obj.pos.x + dt * speed * direction.x, obj.pos.y))
							obj.pos.x += dt * speed * direction.x;
						else if (!map.collision(obj.pos.x, obj.pos.y + dt * speed * direction.y))
							obj.pos.y += dt * speed * direction.y;
						else
							target = null;
					}
				}
				else
				{
					if (!map.collision(target.x, target.y))
					{
						obj.pos.x = target.x;
						obj.pos.y = target.y;
					}
					target = null;
				}
				obj.sortField = obj.pos.y;
				anim_timer = 10 / speed;
		}
		public function set Direction(value:Point):void
		{
			direction = value.clone();
			direction.normalize(1);
		}
		public function get Direction():Point
		{
			return direction;
		}
	}
}