package
{
	import flash.display.BitmapData;
	import flash.geom.Point;
	import org.flashdevelop.utils.FlashConnect;
	public class CProjectile extends CGameObject
	{
		public var height:Number;
		public var targetLoc:Point;
		public var targetHeight:Number;
		public var faction:int; // 0 friend, 1 foe
		public var speed:Number;
		protected var dirX:Number, dirY:Number, dirZ:Number;
		public var explosion:CAnimation = null;
		public var attackRef:CAttackRef=null;
		public function CProjectile()
		{
			
		}
		public function init_projectile(caster:CCreature, speed:Number, faction:int, height:Number, targetLoc:Point, targetHeight:Number, attackRef:CAttackRef=null):void
		{
			this.faction = faction;
			this.speed = speed;
			this.height = height;
			this.targetLoc = targetLoc.clone();
			this.targetHeight = targetHeight;
			this.attackRef = attackRef;
			
			if (caster.movement.look_direction == 0)
				pos.x += caster.shot_offset.x;
			else
				pos.x -= caster.shot_offset.x;
				
			dirX = targetLoc.x - pos.x;
			dirY = targetLoc.y - pos.y;
			dirZ = targetHeight - height;
			var dist:Number = Math.sqrt(dirX * dirX + dirY * dirY + dirZ * dirZ);
			if (dist > 0)
			{
				dirX /= dist;
				dirY /= dist;
				dirZ /= dist;
			}
			
		}
		override public function update(gm:CGameManager, dt:Number):void
		{
			pos.x += dt * speed * dirX;
			pos.y += dt * speed * dirY;
			height += dt * speed * dirZ;
			sortField = pos.y;
			//FlashConnect.trace(pos.x + ", " + pos.y + ", " + height);
			if (height < 0 || height>1000 || !gm.Game.world.currentMap.onMap(pos.x, pos.y))
			{
				active = false;
				gm.Game.removedGameObjects.addItem(this);
				execExplosion(gm);
			}
		}
		override public function draw(backbuffer:BitmapData, scroll:Point, gm:CGameManager):void
		{
			ResManager.img[imgId].draw(backbuffer, pos.x - Math.floor(scroll.x), pos.y - Math.floor(scroll.y), 0);
			ResManager.img[imgId].draw(backbuffer, pos.x - Math.floor(scroll.x), pos.y - Math.floor(scroll.y) - height, frame);
		}
		public function execExplosion(gm:CGameManager):void
		{
			if (explosion)
			{
				explosion.pos.x = pos.x;
				explosion.pos.y = pos.y;
				explosion.height = height;
				explosion.sortField = pos.y + 1;
				gm.Game.newObjectList.addItem(explosion);
				explosion = null;
			}
		}
	}
}