package
{
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import mx.collections.ArrayCollection;
	import org.flashdevelop.utils.FlashConnect;
	import utility.CUtility;
	public class CTileMap
	{
		public var tilesize:int;
		public var mapData:Array;
		protected var dim:Point;
		public var passages:Array = new Array(null, null, null, null);
		public var enemies:ArrayCollection = new ArrayCollection();
		public var finished:Boolean=false;
		public function CTileMap()
		{
			
		}
		public function loadMap(tilesize:int, xDim:int, yDim:int, passages:Array):void
		{
			this.tilesize = tilesize;
			Dim = new Point(xDim, yDim);
			
			mapData = new Array(dim.x);
			for (var x:int = 0; x < dim.x;++x )
			{
				mapData[x] = new Array(dim.y);
				for (var y:int = 0; y < dim.y;++y )
				{
					mapData[x][y] = new CTile();
					if (x == 0 || y == 0 || x == dim.x - 1 || y == dim.y - 1)
					{
						mapData[x][y].imgId = ResManager.IMG_TILES;
						mapData[x][y].frame = 1;
						mapData[x][y].collision = 1;
						
					}
					else
					{
						mapData[x][y].imgId = ResManager.IMG_TILES;
						mapData[x][y].frame = 0;
						mapData[x][y].collision = 0;
					}
				}
			}
			makePassages(passages);
		}
		protected function makePassages(passages:Array):void
		{
			for (var i:int = 0; i < Math.min(4, passages.length); ++i )
			{
				this.passages[i] = passages[i];
				if (this.passages[i])
				{
					switch(i)
					{
						case 0:
							for (var x0:int = 0; x0 < 3;++x0 )
								mapData[int(Math.floor(dim.x / 2) - 1 + x0)][0].frame = mapData[int(Math.floor(dim.x / 2) - 1 + x0)][0].collision = 0;
							this.passages[i].area = new Rectangle((Math.floor(dim.x / 2) - 1) * tilesize, 0, tilesize * 3, tilesize/4);
							break;
						case 1:
							for (var y0:int = 0; y0 < 3;++y0 )
								mapData[dim.x - 1][Math.floor(dim.y / 2) - 1 + y0].frame = mapData[dim.x - 1][Math.floor(dim.y / 2) - 1 + y0].collision = 0;
							this.passages[i].area = new Rectangle((dim.x - 1)*tilesize+tilesize*3/4, (Math.floor(dim.y / 2) - 1)*tilesize, tilesize/4, tilesize*3);
							break;
						case 2:
							for (x0 = 0; x0 < 3;++x0 )
								mapData[Math.floor(dim.x / 2) - 1 + x0][dim.y - 1].frame = mapData[Math.floor(dim.x / 2) - 1 + x0][dim.y - 1].collision = 0;
							this.passages[i].area = new Rectangle((Math.floor(dim.x / 2) - 1)*tilesize, (dim.y - 1)*tilesize+tilesize*3/4, tilesize*3, tilesize/4);
							break;
						case 3:
							for (y0 = 0; y0 < 3;++y0 )
								mapData[0][Math.floor(dim.y / 2) - 1 + y0].frame = mapData[0][Math.floor(dim.y / 2) - 1 + y0].collision = 0;
							this.passages[i].area = new Rectangle(0, (Math.floor(dim.y / 2) - 1)*tilesize, tilesize/4, tilesize*3);
							break;
					}
				}
			}
		}
		public function setTargetLocation(targetId:int, targetMap:CTileMap):Point
		{
			switch(targetId)
			{
				case 0:
					return new Point((Math.floor(targetMap.dim.x / 2)) * tilesize + tilesize / 2, tilesize / 4 + 1);
					break;
				case 1:
					return new Point((targetMap.dim.x) * tilesize - tilesize / 4 - 1, (Math.floor(targetMap.dim.y / 2)) * tilesize + tilesize / 2);
					//FlashConnect.trace(passage.targetLocation.x + ", " + passage.targetLocation.y);
					break;
				case 2:
					return new Point((Math.floor(targetMap.dim.x / 2)) * tilesize+tilesize/2, (targetMap.dim.y) * tilesize-tilesize / 4 - 1);
					break;
				case 3:
					return new Point(tilesize / 4 + 1, (Math.floor(targetMap.dim.y / 2)) * tilesize+tilesize/2);
					break;
			}
			return null;
		}
		public function set Dim(value:Point):void
		{
			var minLength:int = 5;
			dim = new Point(Math.max(minLength, value.x), Math.max(minLength, value.y));
		}
		public function get Dim():Point
		{
			return dim;
		}
		public function draw(backbuffer:BitmapData, scroll:Point):void
		{
			for (var y:int = 0; y < dim.y;++y )
				for (var x:int = 0; x < dim.x;++x )
				{
					(ResManager.img[mapData[x][y].imgId] as AnimImage).draw(backbuffer, x * tilesize-Math.floor(scroll.x), y * tilesize-Math.floor(scroll.y), mapData[x][y].frame);
				}
		}
		public function onMapInt(x:int, y:int):Boolean
		{
			if (x < 0 || x >= dim.x||y < 0||y >= dim.y)
				return false;
			return true;
		}
		public function onMap(x:Number, y:Number):Boolean
		{
			if (x < 0 || x >= dim.x*tilesize||y < 0||y >= dim.y*tilesize)
				return false;
			return true;
		}
		public function collision(x:Number, y:Number):Boolean
		{
			if (!onMapInt(Math.floor(x/tilesize), Math.floor(y/tilesize))) return true;
			if (mapData[Math.floor(x / tilesize)][Math.floor(y / tilesize)].collision == 1)
				return true;
			return false;
		}
		public function resetEnemies():void
		{
			for each(var enemy:CEnemy in enemies)
			{
				enemy.stats.hp = enemy.stats.maxHp;
				enemy.active = true;
				
			}
		}
		public function allEnemiesDead():Boolean
		{
			for each(var enemy:CEnemy in enemies)
				if (enemy.stats.hp > 0)
					return false;
			return true;
		}
		public function getRandomPos(x0:int, y0:int, radius:int, maxReps:int=100):Point
		{
			var i:int = maxReps;
			var normPos:Point;
			var pos:Point;
			do {
				normPos = CUtility.randNormal(0, radius * radius / 9);
				pos = new Point(x0 + normPos.x, y0 + normPos.y)
				--i;
				if (i == 0)
					return new Point();
			}while (this.collision(pos.x, pos.y))
			return pos;
		}

	}
}