package
{
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import utility.CUtility;
	import org.flashdevelop.utils.FlashConnect;
	public class CWorld
	{
		public var introMap:CTileMap;
		public var currentMap:CTileMap;
		protected var maps:Array;
		public function CWorld()
		{
			
		}
		
		public function loadWorld(gm:CGameManager):void
		{
			maps = new Array(7);
			maps[0] = new CTileMap();
			(maps[0] as CTileMap).loadMap(32, 11, 11, [null, new CPassage(1, 3), null, null]);
			setEnemiesMap0(maps[0]);
			changeMap(gm, 0);
			introMap = maps[0];
			
			maps[1] = new CTileMap();
			(maps[1] as CTileMap).loadMap(32, 11, 11, [new CPassage(2, 2), null, new CPassage(3, 0), new CPassage(0, 1)]);
			setEnemiesMap1(maps[1]);
			
			
			maps[2] = new CTileMap();
			(maps[2] as CTileMap).loadMap(32, 11, 9, [null, null, new CPassage(1, 0), null]);
			setEnemiesMap2(maps[2]);
			
			maps[3] = new CTileMap();
			(maps[3] as CTileMap).loadMap(32, 15, 15, [new CPassage(1, 2), new CPassage(4, 3), null, null]);
			setEnemiesMap3(maps[3]);

			maps[4] = new CTileMap();
			(maps[4] as CTileMap).loadMap(32, 11, 11, [null, new CPassage(5, 3), null, new CPassage(3, 1)]);
			setEnemiesMap4(maps[4]);

			maps[5] = new CTileMap();
			(maps[5] as CTileMap).loadMap(32, 11, 11, [null, new CPassage(6, 3), null, new CPassage(4, 1)]);
			setEnemiesMap5(maps[5]);

			maps[6] = new CTileMap();
			(maps[6] as CTileMap).loadMap(32, 13, 13, [null, null, null, new CPassage(5, 1)]);
			setEnemiesMap6(maps[6]);
		}
		public function changeMap(gm:CGameManager, id:int):void
		{
			if (id<0 || id>=maps.length) return;
			for each(var obj:CGameObject in gm.Game.objectList)
			{
				if (obj != gm.Game.dragon)
				{
					//obj.active = false;
					gm.Game.removedGameObjects.addItem(obj);
				}
			}
			//if(currentMap)
				//currentMap.resetEnemies();
			currentMap = maps[id];
			if(!currentMap.finished)
				gm.Game.newObjectList.addAll(currentMap.enemies);
		}
		public function setEnemiesMap0(map:CTileMap):void
		{
			var N:int = 3;
			var radius:int = 5 * map.tilesize;
			for (var i:int = 0; i < N;++i )
			{
			
				map.enemies.addItem(init_Knight(map.getRandomPos((map.Dim.x-3) * map.tilesize, map.Dim.y * map.tilesize / 2, radius), map, 0));
			}
		}
		public function setEnemiesMap1(map:CTileMap):void
		{
			var N:int = 3;
			var radius:int = 5 * map.tilesize;
			for (var i:int = 0; i < N;++i )
			{
			
				map.enemies.addItem(init_Mage(map.getRandomPos(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2, radius), map, 0));
			}
		}
		public function setEnemiesMap2(map:CTileMap):void
		{
			var N:int = 3;
			var radius:int = 5 * map.tilesize;
			for (var i:int = 0; i < N;++i )
			{
				map.enemies.addItem(init_Knight(map.getRandomPos(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2, radius), map, 2, 9));
				map.enemies.addItem(init_Mage(map.getRandomPos(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2, radius), map, 2));
			}
		}
		public function setEnemiesMap3(map:CTileMap):void
		{
			map.enemies.addItem(init_ArchMage(new Point(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2), map));
		}
		public function setEnemiesMap4(map:CTileMap):void
		{
			var N:int = 16;
			var radius:int = 7 * map.tilesize;
			for (var i:int = 0; i < N;++i )
			{
			
				map.enemies.addItem(init_Knight(map.getRandomPos(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2, radius), map, 3, 9));
			}
		}
		public function setEnemiesMap5(map:CTileMap):void
		{
			var N:int = 10;
			var radius:int = 5 * map.tilesize;
			for (var i:int = 0; i < N;++i )
			{
				map.enemies.addItem(init_Knight(map.getRandomPos(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2, radius), map, 4));
				map.enemies.addItem(init_Mage(map.getRandomPos(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2, radius), map, 4));
			}
		}
		public function setEnemiesMap6(map:CTileMap):void
		{
			map.enemies.addItem(init_BigKnight(new Point(map.Dim.x * map.tilesize / 2, map.Dim.y * map.tilesize / 2), map));
		}
		public function init_Knight(pos:Point, map:CTileMap, level:Number=0, fr:int=8):CEnemy
		{
			var stats_per_level:CStats = new CStats();
			stats_per_level.init_stats(50, 50, 0, 5, 5, 10);
			var stats_knight:CStats = new CStats();
			stats_knight.init_stats(100, 100, 10, 25, 10, 20);
			stats_knight.add(level, stats_per_level);
			var enemy:CEnemy = new CEnemy();
			enemy.init_gameObject(pos, ResManager.IMG_DRAGONS, fr * 2, 2);
			enemy.init_creature(25, 13, stats_knight, 1, new Point(), new Point(5, 6));
			enemy.init_enemy(6 * map.tilesize);
			enemy.movement.look_direction = CUtility.rand();
			enemy.attacks[0] = new CAttack_Melee();
			(enemy.attacks[0] as CAttack_Melee).init_attack(70, 0, 100, CAttack.PHYSICAL, 0, 1.2, 1.2);
			return enemy;
		}
		public function init_Mage(pos:Point, map:CTileMap, level:Number = 0):CEnemy
		{
			var stats_per_level:CStats = new CStats();
			stats_per_level.init_stats(20, 20, 5, 0, 15, 2);
			var stats_mage:CStats = new CStats();
			stats_mage.init_stats(100, 100, 25, 10, 20, 10);
			stats_mage.add(level, stats_per_level);
			var enemy:CEnemy = new CEnemy();
			enemy.init_gameObject(pos, ResManager.IMG_DRAGONS, 11 * 2, 2);
			enemy.init_creature(25, 13, stats_mage, 1, new Point(), new Point(5, 14));
			enemy.init_enemy(6 * map.tilesize);
			enemy.movement.look_direction = CUtility.rand();
			enemy.attacks[0] = new CAttack_SingleProjectile();
			(enemy.attacks[0] as CAttack).init_attack(100, 100, 0, CAttack.MAGIC, 3*map.tilesize, 1.5, 1.5);
			return enemy;
		}
		public function init_ArchMage(pos:Point, map:CTileMap):CEnemy_ArchMage
		{
			var stats_mage:CStats = new CStats();
			stats_mage.init_stats(1800, 1800, 100, 10, 40, 30);
			
			var mage:CEnemy_ArchMage = new CEnemy_ArchMage();
			mage.init_gameObject(pos, ResManager.IMG_DRAGONS, 13 * 2, 6);
			mage.init_creature(10, 24, stats_mage, 1, new Point(), new Point(10, 12));
			mage.init_enemy(10000);
			mage.movement.look_direction = CUtility.rand();
			mage.attacks[0] = new CAttack_Circle(5, 12);
			(mage.attacks[0] as CAttack_Circle).init_attack(80, 100, 0, CAttack.MAGIC, 9000, 2.5, 2.5);
			(mage.attacks[0] as CAttack_Circle).frame = 3;
			return mage;
		}
		public function init_BigKnight(pos:Point, map:CTileMap):CEnemy_BigKnight
		{
			var stats_knight:CStats = new CStats();
			stats_knight.init_stats(9000, 9000, 30, 150, 50, 50);
			
			var knight:CEnemy_BigKnight = new CEnemy_BigKnight();
			knight.init_gameObject(pos, ResManager.IMG_DRAGONS, 14 * 2, 12);
			knight.init_creature(20, 26, stats_knight, 1, new Point(), new Point(3, 16));
			knight.init_enemy(10000);
			knight.movement.look_direction = CUtility.rand();
			knight.attacks[0] = new CAttack_Melee();
			(knight.attacks[0] as CAttack_Melee).init_attack(150, 0, 100, CAttack.PHYSICAL, 0, 2, 1.2);
			return knight;
		}
		public function won():Boolean
		{
			if (!maps[maps.length - 1])
				return false;
			return maps[maps.length - 1].finished;
		}
	}
}