package
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	public class ColorImage
	{
		protected var bitmap:BitmapData = null;
		protected var width:int, height:int;
		protected var handle:Point;
		protected var rect:Rectangle;
		protected var baseImage:AnimImage;
		protected var baseFrame:int;
		
		public function ColorImage(img:AnimImage, frame:int, color:CColor)
		{
			baseImage = img;
			baseFrame = frame;
			this.handle = img.Handle.clone();
			rect = new Rectangle(0, 0, img.Width, img.Height);
			bitmap = new BitmapData(img.Width, img.Height);
			setColor(color);
		}
		public function setColor(color:CColor):void
		{
			bitmap.copyPixels(baseImage.getFrame(baseFrame), rect, new Point());
			bitmap.colorTransform(rect, new ColorTransform(1, 1, 1, 1, color.red, color.green, color.blue));
			//bitmap.copyPixels(baseImage.getFrame(baseFrame + 1), rect, new Point(), null, null, true);
		}
		public function draw(backbuffer:BitmapData, x:int, y:int, alphaBitmap:BitmapData=null):void
		{
			backbuffer.copyPixels(bitmap, rect, new Point(x, y).subtract(handle), alphaBitmap, new Point(0, 0), true);
		}
		public function remove():void
		{
			bitmap.dispose();
			bitmap = null;
			handle = null;
			rect = null;
			baseImage = null;
		}
	}
}