package utility
{
	//v: 0.03
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import org.flashdevelop.utils.FlashConnect;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	public final class CUtility
	{
		public static function rand(low:Number=0, high:Number=1):Number
		{
			return Math.floor(Math.random() * (1+high-low)) + low;
		}
		public static function rnd(low:Number=0, high:Number=1):Number
		{
			return (Math.random() * (high-low)) + low;
		}
		public static function randExp(lambda:Number):Number
		{
			var r:Number = Math.random() * 0.9 + 0.05;
			return -Math.log(r) / lambda;
		}
		public static function lineIntersection(s1:Point, v1:Point, s2:Point, v2:Number):Point
		{
			if (isNaN(v1.x) || isNaN(v1.y)) return s1.clone();
			if (v1.x != 0 || v1.y != 0)
			{
				var b:Number = (2 * ((s1.x-s2.x) * v1.x + (s1.y-s2.y) * v1.y));
				var a:Number = v1.x * v1.x + v1.y * v1.y - v2 * v2;
				var c:Number = (s1.x-s2.x) * (s1.x-s2.x) + (s1.y-s2.y) * (s1.y-s2.y);
				var t:Number = (Math.max((-b+Math.sqrt(b*b-4*a*c))/2/a, (-b-Math.sqrt(b*b-4*a*c))/2/a));
				return new Point(s1.x + t * v1.x, s1.y + t * v1.y);
			}
			return s1.clone();
		}
		public static function sgn(x:Number):int
		{
			if (x < 0) return -1;
			if (x > 0) return 1;
			return 0;
		}
		public static function pointAdd(p1:Point, alpha:Number, dir:Point):Point // p1+alpha*dir
		{
			return new Point(p1.x + alpha * dir.x / dir.length, p1.y + alpha * dir.y / dir.length);
		}
		public static function randStdNormal():Point
		{
			//polar method
			var q:Number, u1:Number, u2:Number;
			do {
				u1 = rnd( -1, 1);
				u2 = rnd( -1, 1);
				q = u1 * u1 + u2 * u2;
			}while (q == 0 || q > 1);
			q = Math.sqrt(-2*Math.log(q)/q);
			return new Point(u1*q, u2*q);
		}
		public static function randNormal(mu:Number=0, sigma2:Number=1):Point
		{
			var x:Point = randStdNormal();
			x.x = x.x*Math.sqrt(sigma2)+mu;
			x.y = x.y*Math.sqrt(sigma2)+mu;
			return x;
		}
		public static function inRange(p1:Point, p2:Point, r:Number):Boolean
		{
			return (p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y) <= r * r;
		}
		public static function getClass(obj:Object):Class
		{
			return Class(getDefinitionByName(getQualifiedClassName(obj)));
		}
		public static function getClassName(obj:Object):String
		{
			return getQualifiedClassName(obj);
		}
		public static function Point_Rect_Collide(p:Point, r:Rectangle):Boolean
		{
			if (p.x<r.x ||p.x>r.x+r.width||p.y<r.y||p.y>r.y+r.height)
				return false;
			return true;
		}
	}
}